/*
Zaklady programovani ... soubory
okomentovane priklady ze cviceni
*/

#include<iostream>
#include<fstream> // knihovna pro soubory
#include<string>
#include<iomanip>  // formatovany vystup do souboru nebo na konzoli
using namespace std;

/* otevreme soubor pro zapis (pokud soubor neexisyuje, tak ho vytvori),
   zapiseme do nej jeden radek a pak soubor zase zavreme.
*/
void zapisDoSouboru(string nazev)
{
	ofstream soubor;
	soubor.open(nazev);   // otevru soubor pro zapis
	if (soubor.is_open()) // podarilo se soubor otevrit?
	{
		soubor << "ahoj lidi!" << endl; // zapisu neco do souboru
		soubor.close(); // zavru soubor pro zapis
	}
	else
		cout << "chyba: soubor se nepodarilo otevrit!\n";
	// lepe: throw (string)"chyba: soubor se nepodarilo otevrit!\n";
}

// otevreme soubor pro zapis, ruzne varianty:
void zapisDoSouboru1(string nazev)
{
	ofstream soubor;
//	soubor.open(nazev);            // prepisuje aktualni obsah souboru novym obsahem
	soubor.open(nazev, ios::app);  // prida novy obsah az na konec souboru
//	soubor.open(nazev,ios::trunc); // na zacatku puvodni obsah souboru smaze
	if (soubor.is_open())
	{
		soubor << "cisla:" << endl;
		for (int i = 1; i < 10; i++)
			soubor << i << endl;
		soubor << "\n a to je vsechno." << endl;
		soubor.close();
	}
	else
		cout << "chyba: soubor se nepodarilo otevrit!\n";
}

// otevreme soubor pro cteni, precteme z nej cislo, soubor zase zavreme:
void nactiZeSouboru(string nazev)
{
	int i;
	ifstream soubor;    // zmena
	soubor.open(nazev); // otevru soubor
	if (soubor.is_open())
	{
		soubor >> i;    // zmena
		soubor.close();
		cout << i << endl;
	}
	else
		cout << "chyba: soubor se nepodarilo otevrit!\n";
}

/* otevreme soubor pro cteni, precteme z nej cisla,
   soubor zase zavreme:
   */
void nactiZeSouboru0(string nazev)
{
	int i;
	ifstream soubor;    // zmena
	soubor.open(nazev); // otevru soubor
	if (soubor.is_open())
	{
//		while (soubor)
		while(soubor.good())
		{
			soubor >> i;
			if (soubor.fail())
			{
				soubor.clear();
				soubor.ignore(256, '\n');
				continue;
			}
			if(soubor)
				cout << i << endl;
		}
		soubor.close();
	}
	else
		cout << "chyba: soubor se nepodarilo otevrit!\n";
}

/* otevreme soubor pro cteni, cteme z nej po radcich,
   soubor zase zavreme:
   */
void nactiZeSouboru1(string nazev)
{
	string s;
	ifstream soubor;    // zmena
	soubor.open(nazev); // otevru soubor
	if (soubor.is_open())
	{
		while (!soubor.eof())
		{
			getline(soubor, s);
			cout << s << endl;
		}
		soubor.close();
	}
	else
		cout << "chyba: soubor se nepodarilo otevrit!\n";
}

// datovy proud jako parametr funkce:
void zapis(ostream &s, int x)
{
	s << x << endl;
}

// ukazka formatovaneho vypisu:
void zapis1(ostream &s)
{
	const double pi = 3.1415;
	s << setprecision(3) << left << setw(10) << setfill('_') << pi;
	s << setprecision(3) << right << setw(10) << setfill('-') << pi << endl;
}


void zapisDoSouboru2(string nazev)
{
	ofstream soubor;
	soubor.open(nazev); // otevru soubor
	if (soubor.is_open())
	{
		// vypis do souboru:
		zapis(soubor, 4);
		zapis1(soubor);

		// vypis na konzoli:
		zapis(cout, -4);
		zapis1(cout);

		soubor.close();
	}
	else
		cout << "chyba: soubor se nepodarilo otevrit!\n";
}

// ukazka prace s datovym proudem cout:
void ukazkaCout()

{
	int a, b, c;
	cout << "zadej a: ";
	cin >> a;
	cin.ignore(256, '\n');
	cout << "zadej b: ";
	cin >> b;
	cout << "zadej c: ";
	cin >> c;
	cout << a << " " << b << " " << c;
	string s;
	//cin >> s;
	//getline(cin, s);
	getline(cin, s, ';');
	cout << s;
}

// priklad na cviceni:
/*
int pocetRadku(string nazev);
string *nactiRadky(string nazev, int n);
void vypisRadkyOpacne(string *radky, int n, string nazev);

void priklad()
{
	int n = pocetRadku("soubor.txt");
	string *radky = nactiRadky("soubor.txt", n);
	vypisRadkyOpacne(radky, n, "souborO.txt");
	delete[] radky;
}
*/

int main()
{
	zapisDoSouboru("prvni.txt");
	zapisDoSouboru(".\\nova\\prvni.txt");
	zapisDoSouboru("M:\\prvni.txt");
	zapisDoSouboru1("druhy.txt");

	zapisDoSouboru2("treti.txt");

	nactiZeSouboru("druhy.txt");
	nactiZeSouboru0("druhy.txt");
	nactiZeSouboru1("druhy.txt");

	zapis(cout, 5);
	zapis(cout, 3);

	return 0;
}